import 'reflect-metadata';
import { TypeKeys } from 'web-utility';
import { ValidationError } from 'class-validator';
import { BaseModel, BaseListModel } from '../Base';
export declare function toggle<T extends BaseModel>(property: TypeKeys<T, boolean | number>): (target: any, key: string, meta: PropertyDescriptor) => void;
export declare function Input(): ParameterDecorator;
export declare type InvalidMessage<T> = Partial<Record<keyof T, ValidationError['constraints']>>;
export declare class InvalidError extends Error {
    static from<T>(state: InvalidMessage<T>): InvalidError;
}
export declare function validate<T extends BaseListModel<{}>>(): (target: any, key: string, meta: PropertyDescriptor) => void;
