import { TypeKeys } from 'web-utility';
import { HTTPClient, Context } from 'koajax';
export declare type AbstractClass<I> = abstract new (...data: any[]) => I;
export declare type IDType = number | string;
export declare type DataObject = Record<string, any>;
export declare type NewData<T extends DataObject> = Partial<Omit<T, TypeKeys<T, DataObject> | TypeKeys<T, DataObject[]>> & {
    [K in TypeKeys<T, DataObject>]: IDType;
} & {
    [K in TypeKeys<T, DataObject[]>]: IDType[];
}>;
export declare type RESTClient = Pick<HTTPClient<Context>, 'baseURI' | 'options' | 'request' | 'get' | 'post' | 'put' | 'patch' | 'delete'>;
